//Planet earth
  float diameter;
  color surface;
  float angle;
  
void setup(){
  size(800, 600);
  
//inialise planet earth
  diameter = 12756;    //in 1000km
  surface = #00FF00;   //it's a green planet
  angle = random(350); //it's a new day
}

void orbit(float radiusX, float radiusY, float orbitTime){
    // draw ellipse first, so it's under planet earth
    drawOrbit(radiusX, radiusY);
    float px = cos(radians(angle))*radiusX/2;
    float py = sin(radians(angle))*radiusY/2;
    
    // draw planet earth next 
    fill(surface);
    noStroke();
    ellipse(px, py, diameter/2000, diameter/2000);
    
    //move forward
    angle += (1/orbitTime);
}

void drawOrbit(float radiusX, float radiusY){
     //make the entire orbit visible
     stroke(255,50);
     float angle=0;
     for (int i=0; i<360; i++){
         point(cos(radians(angle))*radiusX/2, 
               sin(radians(angle++))*radiusY/2);
     }
}
  
void draw(){
  background(0);
  translate(width/2, height/2);
  orbit(150, 153, 1.00);
  //min and max distance to sun in 1000000km
  //rotation time in years
}
